<!DOCTYPE html>
<html lang="en">

    <head><title>A personal VIM cheatsheet &ndash; simple pages</title>


<meta name="viewport" content="width=device-width, initial-scale=1">
<meta charset="UTF-8"/>



<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.1/css/all.min.css" integrity="sha512-DTOQO9RWCH3ppGqcWaEA1BIZOC6xxalwEsw9c2QQeAIftl+Vegovlnee1c9QX4TctnWMn13TZye+giMm8e2LwA==" crossorigin="anonymous" referrerpolicy="no-referrer" />


<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/academicons/1.9.4/css/academicons.min.css" integrity="sha512-IW0nhlW5MgNydsXJO40En2EoCkTTjZhI3yuODrZIc8cQ4h1XcF53PsqDHa09NqnkXuIe0Oiyyj171BqZFwISBw==" crossorigin="anonymous" referrerpolicy="no-referrer" />

<link rel="stylesheet" href="https://simplepages.xyz/css/palettes/solarized-light.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/risotto.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/colours.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/typography.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/layout.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/header.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/logo.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/about.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/footer.css">
<link rel="stylesheet" href="https://simplepages.xyz/css/custom.css">










</head>

    <body>
        <div class="page">

            <header class="page__header"><nav class="page__nav main-nav">
    <ul>
      <li class="nomarker"><h1 class="page__logo"><a href="https://simplepages.xyz" class="page__logo-inner">simple pages</a></h1></li>

    
    
    <li class="main-nav__item"><a class="nav-main-item" href="https://simplepages.xyz/about/" title="">about</a></li>
    
    <li class="main-nav__item"><a class="nav-main-item" href="https://simplepages.xyz/posts/" title="">posts</a></li>
    
    </ul>
</nav>

</header>

            <section class="page__body">
    <header class="content__header">
        <h1>A personal VIM cheatsheet</h1>
    </header>
    <br>
    <div class="content__body">
        <p>This page contains a personal cheat sheet of VIM commands, keybindings or other snippets I find handy to keep around.
Because my understanding constantly changes, this page also is subject to change.</p>
<blockquote>
<p>If you want to go through a VIM tutorial on your own (Linux) system, type &ldquo;vimtutor&rdquo; in your terminal.</p>
</blockquote>
<h2 id="keys">Keys</h2>
<p>These are keys pressed starting from the normal mode (ESC to go to normal mode) in VIM.</p>
<ul>
<li>CTRL+o: Go back to your previous cursor position.</li>
<li>CTRL+i: Go forward to your previous cursor position after using CTRL + o.</li>
<li>%: With your cursor on a bracket ( &ldquo;[&rdquo;,&quot;(&quot;,&quot;{&quot; ), it will bring you to the matching bracket.</li>
<li>?: Search for the given phrase backwards.</li>
<li>/: Search for the given phrase forwards.</li>
<li>:set ignorecase: Ignore case while searching.</li>
<li>:set hlsearch: Highlight matches.</li>
<li>:set incsearch: Start searching while typing.</li>
<li>^: Move the cursor to the first character in the beginning of the current line.</li>
<li>0: Move the cursor to the absolute beginning of the current line.</li>
<li>n: While searching, search for the next match forwards.</li>
<li>N: While searching, search for the next match backwards.</li>
<li>p: Paste text currently in the register (after deleting or yanking) below current line.</li>
<li>R: Replace the characters starting from the cursor until &ldquo;ESC&rdquo; key pressed.</li>
<li>u: Undo previous change.</li>
<li>U: Undo all changes to the current line.</li>
<li>v: Start visual selection</li>
<li>yw: Yank (copy) a word.</li>
<li>yy: Yank a line.</li>
<li>zt: Scroll the current line to the top of the screen.</li>
<li>SHIFT+v: Start visual selection in line mode.</li>
<li>After this, you can delete whole lines with an operator, like &ldquo;d&rdquo; (delete).</li>
<li>After thise, save selected files with &ldquo;:w <filename>&rdquo;.<br>
CTRL+v: Start visual selection in block mode.</li>
<li>After this, you can delete text you selected with the &ldquo;x&rdquo; operator.</li>
<li>You can also insert text after selecting after pressing keys &ldquo;SHIFT+i&rdquo; and the &ldquo;ESC&rdquo; key. Text will be duplicated on each line.</li>
<li>cc: Delete the line and go into insert mode.</li>
<li>ce: Delete the word and go into insert mode.</li>
<li>d2w: Delete the next two words.</li>
<li>2dd: Delete 2 lines, the current and next line. Alternative: &ldquo;d2d&rdquo;.</li>
<li>2e: Move the cursor to the end of the second word forward.</li>
<li>2w: Move the cursor to the beginning of the second word forward.</li>
<li>:s/old/new: Replace &ldquo;old&rdquo; string with &ldquo;new&rdquo; string on the current line.</li>
<li>:s/old/new/g: Replace &ldquo;old&rdquo; string with &ldquo;new&rdquo; string in the current file.</li>
<li>:s/old/new/gc: Replace &ldquo;old&rdquo; string with &ldquo;new&rdquo; string in the current file, prompting for each replacement.</li>
<li>:#,#s/old/new/g: Replace &ldquo;old&rdquo; string with &ldquo;new&rdquo; string between specific line numbers, &ldquo;#,#&rdquo;.</li>
<li>:!ls: Run the &ldquo;ls&rdquo; command in the underlying terminal.</li>
<li>:r !ls: Run the &ldquo;ls&rdquo; command in the underlying terminal and place the output under the cursor.</li>
<li>:r &lt;filepath&gt;: Place the contents of the filepath under the cursor. Can be a absolute or relative path.</li>
<li>:&lt;linenumber&gt; + G: Go to the line number you&rsquo;ve entered.</li>
<li>:set ruler: Show positional information in the bottom right corner.</li>
</ul>

    </div>
    <footer class="content__footer"></footer>

            </section>

            <section class="page__aside">
                <div class="aside__about">

<ul class="aside__social-links">
    
</ul>
</div>
                <hr>
                <div class="aside__content">
    
      Vim cheat sheet<br>

    2024-03-02

    
	    <hr>
	    Table Of Contents:
	    <nav id="TableOfContents">
  <ol>
    <li><a href="#keys">Keys</a></li>
  </ol>
</nav>
    

                </div>
            </section>

            <footer class="page__footer"><p class="copyright"></p>
<p class="advertisement">Powered by <a href="https://gohugo.io/">hugo</a> and <a href="https://github.com/joeroe/risotto">risotto</a>.</p>
</footer>

        </div>
    </body>

</html>
